searchData={"items":[{"type":"module","title":"cozo","doc":"Main interface to CozoDB Erlang NIF cozo_nif module.","ref":"cozo.html"},{"type":"function","title":"cozo.backup/2","doc":"Backup a database to a file. see https://docs.cozodb.org/en/latest/nonscript.html#API.backup Examples { ok , _ } = cozo : backup ( Db , &quot;/tmp/backup.db&quot; ) .","ref":"cozo.html#backup/2"},{"type":"function","title":"cozo.close/1","doc":"Close an opened database. Examples ok = cozo : close ( 0 ) .","ref":"cozo.html#close/1"},{"type":"function","title":"cozo.compact/1","doc":"Unstable interface. Instructs Cozo to run a compaction job. Examples { ok , _ } = cozo : compact ( Db ) .","ref":"cozo.html#compact/1"},{"type":"function","title":"cozo.create_filepath/3","doc":null,"ref":"cozo.html#create_filepath/3"},{"type":"function","title":"cozo.create_relation/3","doc":"Unstable interface. Create a stored relation with the given name and spec. No stored relation with the same name can exist beforehand. Examples { ok , _ } = cozo : create_relation ( Db , &quot;stored1&quot; , &quot;c1&quot; ) . % :create stored1 {c1} { ok , _ } = cozo : create_relation ( Db , stored2 , c1 ) . % :create stored2 {c1} { ok , _ } = cozo : create_relation ( Db , stored3 , [ &quot;c1&quot; , &quot;c2&quot; , &quot;c3&quot; ] ) . % :create stored3 {c1,c2,c3} { ok , _ } = cozo : create_relation ( Db , stored4 , [ c1 , c2 , c3 ] ) . % :create stored4 {c1,c2,c3}","ref":"cozo.html#create_relation/3"},{"type":"function","title":"cozo.describe/3","doc":"Unstable interface. Describe the stored relation and store it in the metadata. Examples { ok , _ } = cozo : describe ( Db , Relation ) . See also: run/4 .","ref":"cozo.html#describe/3"},{"type":"function","title":"cozo.ensure_not_row/3","doc":"Unstable interface. Ensure that rows specified by the output relation and spec do not exist in the database and that no other process has written to these rows when the enclosing transaction commits. Examples { ok , _ } = cozo : ensure_not_row ( Db , Name , Spec ) .","ref":"cozo.html#ensure_not_row/3"},{"type":"function","title":"cozo.ensure_row/3","doc":"Unstable interface. Ensure that rows specified by the output relation and spec exist in the database, and that no other process has written to these rows when the enclosing transaction commits. Useful for ensuring read-write consistency. Examples { ok , _ } = cozo : ensure_row ( Db , Name , Spec ) .","ref":"cozo.html#ensure_row/3"},{"type":"function","title":"cozo.explain/2","doc":"Unstable interface. Explain a query. see https://docs.cozodb.org/en/latest/sysops.html#explain Examples Query = &quot;?[] &lt;- [[&#39;hello&#39;, &#39;world&#39;, &#39;Cozo!&#39;]]&quot; , { ok , _ } = ( Db , Query ) .","ref":"cozo.html#explain/2"},{"type":"function","title":"cozo.export_relations/2","doc":"Export database relationships from json as map. see https://docs.cozodb.org/en/latest/nonscript.html#API.export_relations Examples { ok , _ } = cozo : export_relations ( Db , #{ } ) .","ref":"cozo.html#export_relations/2"},{"type":"function","title":"cozo.get_running_queries/1","doc":"Unstable interface. Display running queries and their id. Examples { ok , _ } = cozo : get_running_queries ( Db ) .","ref":"cozo.html#get_running_queries/1"},{"type":"function","title":"cozo.get_triggers/2","doc":"Unstable interface. Display triggers. Examples { ok , _ } = cozo : get_triggers ( Db , Trigger ) .","ref":"cozo.html#get_triggers/2"},{"type":"function","title":"cozo.import_backup/2","doc":"Import a database backup from json like object as map. see https://docs.cozodb.org/en/latest/nonscript.html#API.import_from_backup Examples { ok , _ } = cozo : import_backup ( Db , #{ } ) .","ref":"cozo.html#import_backup/2"},{"type":"function","title":"cozo.import_relations/2","doc":"Import relations as json. see https://docs.cozodb.org/en/latest/nonscript.html#API.import_relations Examples { ok , _ } = cozo : import_relations ( Db , #{ } ) .","ref":"cozo.html#import_relations/2"},{"type":"function","title":"cozo.json_decoder/0","doc":"returns the default json decoder (thoas)","ref":"cozo.html#json_decoder/0"},{"type":"function","title":"cozo.json_encoder/0","doc":"returns the default json encoder (thoas)","ref":"cozo.html#json_encoder/0"},{"type":"function","title":"cozo.kill/2","doc":"Unstable interface. Kill a running query specified by id. Examples { ok , _ } = cozo : kill ( Db , Id ) .","ref":"cozo.html#kill/2"},{"type":"function","title":"cozo.list_columns/2","doc":"Unstable interface. List all columns for the stored relation. Examples { ok , _ } = cozo : list_columns ( Db , Column ) .","ref":"cozo.html#list_columns/2"},{"type":"function","title":"cozo.list_indices/2","doc":"Unstable interface. List all indices for the stored relation. Examples { ok , _ } = cozo : list_indices ( Db , Indice ) .","ref":"cozo.html#list_indices/2"},{"type":"function","title":"cozo.list_relations/1","doc":"Unstable interface. Returns the list of relations. Examples { ok , _ } = cozo : list_relations ( Db ) .","ref":"cozo.html#list_relations/1"},{"type":"function","title":"cozo.open/0","doc":"Open the database with mem engine, with random path and default options. Examples rr ( cozo ) { ok , { 0 , State } } = cozo : open ( ) . # cozo { id = 0 , db_engine = mem , db_path = &quot;/tmp/cozodb_Lq4yHM0RbGxbIwlyPBcNPyqPEj7O4msJ&quot; , db_options = #{ } , db_parent = &lt; 0.161 &gt; } = State . See also: open/1 , open/2 , open/3 .","ref":"cozo.html#open/0"},{"type":"function","title":"cozo.open/1","doc":"Open a new database with custom engine and random path. The random path is set to /tmp` by default and the filename is prefixed by `cozodb_ . Examples rr ( cozo ) . { ok { 0 , # cozo { db_path = Path } } } = open ( mem ) . &quot;/tmp/cozodb_aPmybeM4XTudF5qJPnG5hJusV2Evq5au&quot; = Path . { ok , { 1 , # cozo { db_path = SqlitePath } } } = open ( sqlite ) . &quot;/tmp/cozodb_TDE4dQKtiXHIUjWyNEaAo1f7LAxrYk4O&quot; = SqlitePath . { ok , { 1 , # cozo { db_path = RocksDbPath } } } = open ( rocksdb ) . &quot;/tmp/cozodb_S8jAUccVnge0cKfci9FYvjrK1O6fAO1S&quot; = RocksDbPath See also: open/2 , open/3 .","ref":"cozo.html#open/1"},{"type":"function","title":"cozo.open/2","doc":"Open a database with a custom engine and path. Examples { ok , { 0 , State } } = cozo : open ( sqlite , &quot;/tmp/database.db&quot; ) . See also: open/3 .","ref":"cozo.html#open/2"},{"type":"function","title":"cozo.open/3","doc":"Open a new databse with custom path and options. Examples { ok , { 0 , State } } = cozo : open ( rocksdb , &quot;/tmp/rocks.db&quot; , #{ } ) .","ref":"cozo.html#open/3"},{"type":"function","title":"cozo.put_row/3","doc":"Unstable interface. Put rows from the resulting relation into the named stored relation. Examples { ok , _ } = cozo : put_row ( Db , Name , Spec ) .","ref":"cozo.html#put_row/3"},{"type":"function","title":"cozo.remove_relation/2","doc":"Unstable interface. Remove a stored relation. Examples { ok , _ } = cozo : remove_relations ( Db , Relation ) . See also: run/4 .","ref":"cozo.html#remove_relation/2"},{"type":"function","title":"cozo.remove_relations/2","doc":"Unstable interface. Remove a stored relations. Examples { ok , _ } = cozo : remove_relations ( Db , [ R1 , R2 , R3 ] ) .","ref":"cozo.html#remove_relations/2"},{"type":"function","title":"cozo.remove_row/3","doc":"Unstable interface. Remove rows from the named stored relation. Examples { ok , _ } = cozo : remove_row ( Db , Name , Spec ) .","ref":"cozo.html#remove_row/3"},{"type":"function","title":"cozo.replace_relation/3","doc":"Unstable interface. Similar to :create , except that if the named stored relation exists beforehand, it is completely replaced. Examples { ok , _ } = cozo : replace_relation ( Db , Name , Spec ) .","ref":"cozo.html#replace_relation/3"},{"type":"function","title":"cozo.restore/2","doc":"Restore a database based from a backup path. see https://docs.cozodb.org/en/latest/nonscript.html#API.restore Examples { ok , _ } = cozo : restore ( Db , &quot;/tmp/backup.db&quot; ) .","ref":"cozo.html#restore/2"},{"type":"function","title":"cozo.run/2","doc":"run a query using cozoscript on defined db and custom query. No parameters are passed and immutability is set to true. Examples { ok , #{ &lt;&lt; &quot;headers&quot; &gt;&gt; =&gt; [ &lt;&lt; &quot;_0&quot; &gt;&gt; , &lt;&lt; &quot;_1&quot; &gt;&gt; , &lt;&lt; &quot;_2&quot; &gt;&gt; ] &lt;&lt; &quot;next&quot; &gt;&gt; =&gt; null , &lt;&lt; &quot;ok&quot; &gt;&gt; =&gt; true , &lt;&lt; &quot;rows&quot; &gt;&gt; =&gt; [ [ 1 , 2 , 3 ] ] , &lt;&lt; &quot;took&quot; &gt;&gt; =&gt; 2.40886e-4 } } = cozo : run ( 0 , &quot;?[] &lt;- [[1, 2, 3]]&quot; ) .","ref":"cozo.html#run/2"},{"type":"function","title":"cozo.run/3","doc":"run a query using cozoscript on defined db with custom params. Immutability is set to true. Examples { ok , #{ &lt;&lt; &quot;headers&quot; &gt;&gt; =&gt; [ &lt;&lt; &quot;_0&quot; &gt;&gt; , &lt;&lt; &quot;_1&quot; &gt;&gt; , &lt;&lt; &quot;_2&quot; &gt;&gt; ] &lt;&lt; &quot;next&quot; &gt;&gt; =&gt; null , &lt;&lt; &quot;ok&quot; &gt;&gt; =&gt; true , &lt;&lt; &quot;rows&quot; &gt;&gt; =&gt; [ [ 1 , 2 , 3 ] ] , &lt;&lt; &quot;took&quot; &gt;&gt; =&gt; 2.40886e-4 } } = cozo : run ( 0 , &quot;?[] &lt;- [[1, 2, 3]]&quot; , #{ } ) .","ref":"cozo.html#run/3"},{"type":"function","title":"cozo.run/4","doc":"Run a query using cozoscript. Examples { ok , #{ &lt;&lt; &quot;headers&quot; &gt;&gt; =&gt; [ &lt;&lt; &quot;_0&quot; &gt;&gt; , &lt;&lt; &quot;_1&quot; &gt;&gt; , &lt;&lt; &quot;_2&quot; &gt;&gt; ] &lt;&lt; &quot;next&quot; &gt;&gt; =&gt; null , &lt;&lt; &quot;ok&quot; &gt;&gt; =&gt; true , &lt;&lt; &quot;rows&quot; &gt;&gt; =&gt; [ [ 1 , 2 , 3 ] ] , &lt;&lt; &quot;took&quot; &gt;&gt; =&gt; 2.40886e-4 } } = cozo : run ( 0 , &quot;?[] &lt;- [[1, 2, 3]]&quot; , #{ limit =&gt; 10 } , falsex ) .","ref":"cozo.html#run/4"},{"type":"function","title":"cozo.set_access_level/3","doc":"Unstable interface. Examples { ok , _ } = cozo : set_access_level ( Db , Level , Name ) .","ref":"cozo.html#set_access_level/3"},{"type":"function","title":"cozo.set_access_levels/3","doc":"Unstable interface. Examples { ok , _ } = cozo : se_access_levelss ( Db , Level , [ N1 , N2 , N3 ] ) .","ref":"cozo.html#set_access_levels/3"},{"type":"function","title":"cozo.update_row/3","doc":"Unstable interface. Update rows in the named stored relation. Examples { ok , _ } = cozo : update_row ( Db , Name , Spec ) .","ref":"cozo.html#update_row/3"},{"type":"type","title":"cozo.db_engine/0","doc":null,"ref":"cozo.html#t:db_engine/0"},{"type":"type","title":"cozo.db_id/0","doc":null,"ref":"cozo.html#t:db_id/0"},{"type":"type","title":"cozo.db_options/0","doc":null,"ref":"cozo.html#t:db_options/0"},{"type":"type","title":"cozo.db_parent/0","doc":null,"ref":"cozo.html#t:db_parent/0"},{"type":"type","title":"cozo.db_path/0","doc":null,"ref":"cozo.html#t:db_path/0"},{"type":"type","title":"cozo.db_query/0","doc":null,"ref":"cozo.html#t:db_query/0"},{"type":"type","title":"cozo.query_mutable/0","doc":null,"ref":"cozo.html#t:query_mutable/0"},{"type":"type","title":"cozo.query_params/0","doc":null,"ref":"cozo.html#t:query_params/0"},{"type":"type","title":"cozo.query_return/0","doc":null,"ref":"cozo.html#t:query_return/0"},{"type":"module","title":"cozo_app","doc":null,"ref":"cozo_app.html"},{"type":"function","title":"cozo_app.start/2","doc":null,"ref":"cozo_app.html#start/2"},{"type":"function","title":"cozo_app.stop/1","doc":null,"ref":"cozo_app.html#stop/1"},{"type":"module","title":"cozo_db","doc":"Isolated cozodb in gen_statem process.","ref":"cozo_db.html"},{"type":"function","title":"cozo_db.backup/2","doc":"See also: cozo:backup/2 .","ref":"cozo_db.html#backup/2"},{"type":"function","title":"cozo_db.call/2","doc":null,"ref":"cozo_db.html#call/2"},{"type":"function","title":"cozo_db.call/3","doc":null,"ref":"cozo_db.html#call/3"},{"type":"function","title":"cozo_db.callback_mode/0","doc":null,"ref":"cozo_db.html#callback_mode/0"},{"type":"function","title":"cozo_db.cast/2","doc":null,"ref":"cozo_db.html#cast/2"},{"type":"function","title":"cozo_db.compact/1","doc":"See also: cozo:compact/1 .","ref":"cozo_db.html#compact/1"},{"type":"function","title":"cozo_db.create_relation/3","doc":"See also: cozo:create_relation/3 .","ref":"cozo_db.html#create_relation/3"},{"type":"function","title":"cozo_db.describe/3","doc":"See also: cozo:describe/3 .","ref":"cozo_db.html#describe/3"},{"type":"function","title":"cozo_db.ensure_not_row/3","doc":"See also: cozo:ensure_not_row/3 .","ref":"cozo_db.html#ensure_not_row/3"},{"type":"function","title":"cozo_db.ensure_row/3","doc":"See also: cozo:ensure_row/3 .","ref":"cozo_db.html#ensure_row/3"},{"type":"function","title":"cozo_db.explain/2","doc":"See also: cozo:explain/2 .","ref":"cozo_db.html#explain/2"},{"type":"function","title":"cozo_db.export_relations/2","doc":"See also: cozo:export_relations/2 .","ref":"cozo_db.html#export_relations/2"},{"type":"function","title":"cozo_db.get_running_queries/1","doc":"See also: cozo:get_running_queries/1 .","ref":"cozo_db.html#get_running_queries/1"},{"type":"function","title":"cozo_db.get_triggers/2","doc":"See also: cozo:get_triggers/2 .","ref":"cozo_db.html#get_triggers/2"},{"type":"function","title":"cozo_db.import_backup/2","doc":"See also: cozo:import_backup/2 .","ref":"cozo_db.html#import_backup/2"},{"type":"function","title":"cozo_db.import_relations/2","doc":"See also: cozo:import_relations/2 .","ref":"cozo_db.html#import_relations/2"},{"type":"function","title":"cozo_db.init/1","doc":null,"ref":"cozo_db.html#init/1"},{"type":"function","title":"cozo_db.kill/2","doc":"See also: cozo:kill/2 .","ref":"cozo_db.html#kill/2"},{"type":"function","title":"cozo_db.list_columns/2","doc":"See also: cozo:list_columns/2 .","ref":"cozo_db.html#list_columns/2"},{"type":"function","title":"cozo_db.list_indices/2","doc":"See also: cozo:list_indices/2 .","ref":"cozo_db.html#list_indices/2"},{"type":"function","title":"cozo_db.list_relations/1","doc":"See also: cozo:list_relations/1 .","ref":"cozo_db.html#list_relations/1"},{"type":"function","title":"cozo_db.put_row/3","doc":"See also: cozo:put_row/3 .","ref":"cozo_db.html#put_row/3"},{"type":"function","title":"cozo_db.remove_relation/2","doc":"See also: cozo:remove_relation/2 .","ref":"cozo_db.html#remove_relation/2"},{"type":"function","title":"cozo_db.remove_row/3","doc":"See also: cozo:remove_row/3 .","ref":"cozo_db.html#remove_row/3"},{"type":"function","title":"cozo_db.replace_relation/3","doc":"See also: cozo:replace_relation/3 .","ref":"cozo_db.html#replace_relation/3"},{"type":"function","title":"cozo_db.restore/2","doc":"See also: cozo:restore/2 .","ref":"cozo_db.html#restore/2"},{"type":"function","title":"cozo_db.run/2","doc":"See also: cozo:run/2 .","ref":"cozo_db.html#run/2"},{"type":"function","title":"cozo_db.run/3","doc":"See also: cozo:run/3 .","ref":"cozo_db.html#run/3"},{"type":"function","title":"cozo_db.run/4","doc":"See also: cozo:run/4 .","ref":"cozo_db.html#run/4"},{"type":"function","title":"cozo_db.set_access_level/3","doc":"See also: cozo:set_access_level/3 .","ref":"cozo_db.html#set_access_level/3"},{"type":"function","title":"cozo_db.set_access_levels/3","doc":"See also: cozo:set_access_levels/3 .","ref":"cozo_db.html#set_access_levels/3"},{"type":"function","title":"cozo_db.standard/3","doc":null,"ref":"cozo_db.html#standard/3"},{"type":"function","title":"cozo_db.start/1","doc":null,"ref":"cozo_db.html#start/1"},{"type":"function","title":"cozo_db.start/2","doc":null,"ref":"cozo_db.html#start/2"},{"type":"function","title":"cozo_db.start_link/1","doc":null,"ref":"cozo_db.html#start_link/1"},{"type":"function","title":"cozo_db.start_link/2","doc":null,"ref":"cozo_db.html#start_link/2"},{"type":"function","title":"cozo_db.start_monitor/1","doc":null,"ref":"cozo_db.html#start_monitor/1"},{"type":"function","title":"cozo_db.start_monitor/2","doc":null,"ref":"cozo_db.html#start_monitor/2"},{"type":"function","title":"cozo_db.stop/1","doc":null,"ref":"cozo_db.html#stop/1"},{"type":"function","title":"cozo_db.terminate/3","doc":null,"ref":"cozo_db.html#terminate/3"},{"type":"function","title":"cozo_db.update_row/3","doc":"See also: cozo:update_row/3 .","ref":"cozo_db.html#update_row/3"},{"type":"module","title":"cozo_sup","doc":null,"ref":"cozo_sup.html"},{"type":"function","title":"cozo_sup.init/1","doc":null,"ref":"cozo_sup.html#init/1"},{"type":"function","title":"cozo_sup.start_link/0","doc":null,"ref":"cozo_sup.html#start_link/0"},{"type":"extras","title":"cozo","doc":"# cozo\n\n![Cozo License](https://img.shields.io/github/license/niamtokik/cozo)\n![Cozo Top Language](https://img.shields.io/github/languages/top/niamtokik/cozo)\n![Cozo Workflow Status (main branch)](https://img.shields.io/github/actions/workflow/status/niamtokik/cozo/test.yaml?branch=main)\n![Cozo Last Commit](https://img.shields.io/github/last-commit/niamtokik/cozo)\n![Cozo Code Size (bytes)](https://img.shields.io/github/languages/code-size/niamtokik/cozo)\n![Cozo Repository File Count](https://img.shields.io/github/directory-file-count/niamtokik/cozo)\n![Cozo Repository Size](https://img.shields.io/github/repo-size/niamtokik/cozo)\n\nThis is an Erlang NIF wrapper for [CozoDB](https://www.cozodb.org), a FOSS embeddable, transactional, relational-graph-vector database, with time travelling capability, perfect as the long-term memory for LLMs and AI.","ref":"readme.html"},{"type":"extras","title":"Support - cozo","doc":"- [x] `cozo_open_db` with `cozo:open/0` and `cozo:open/2`.\n - [x] `cozo_close_db` with `cozo:close/1`\n - [x] `cozo_run_query` with `cozo:run/2`, `cozo:run/3` and `cozo:run/4`\n - [x] `cozo_import_relations` with `cozo:import_relations/2`\n - [x] `cozo_export_relations` with `cozo:export_relations/2`\n - [x] `cozo_backup`  with `cozo:backup/2`\n - [x] `cozo_restore`  with `cozo:restore/2`\n - [x] `cozo_import_from_backup`  with `cozo:import_backup/2`","ref":"readme.html#support"},{"type":"extras","title":"Todo - cozo","doc":"- [ ] Create test suite for `cozo` module\n   - [x] test `cozo:open` function\n   - [x] test `cozo:close` function\n   - [x] test `cozo:run` function\n   - [ ] test `cozo:import_relations` function\n   - [ ] test `cozo:export_relation` function\n   - [ ] test `cozo:backup` function\n   - [ ] test `cozo:restore` function\n   - [ ] test `cozo:import_backup` function\n - [x] Create `cozo_db` module to deal with strong isolation\n - [x] Create test suite for `cozo_nif` module\n - [x] Specify interfaces\n - [ ] Add property based testing support\n - [x] Add Dialyzer support\n - [ ] Create more usage example\n - [ ] Create distributed example\n - [ ] Check if `cozo_nif.c` is safe","ref":"readme.html#todo"},{"type":"extras","title":"Build - cozo","doc":"This project is using `Makefile` to extend the capability of\nrebar3. everything can be easily done with it.\n\n```sh\nmake all\n# or\nmake deps compile\n```","ref":"readme.html#build"},{"type":"extras","title":"Test - cozo","doc":"A full test suite is present in `test/cozo_SUITE.erl` file, using the\ncozodb tutorial present in the official documentation as template.\n\n```sh\nmake test\n```","ref":"readme.html#test"},{"type":"extras","title":"Documentation - cozo","doc":"Generate the project documentation.\n\n```sh\nmake doc\n```\n\nOpen the documentation.\n\n```sh\nopen doc/index.html\n```","ref":"readme.html#documentation"},{"type":"extras","title":"Usage - cozo","doc":"Open a shell with `make`\n\n```sh\nmake shell\n```\n\nIf you want to create a totally isolated database in its own process,\nyou can use `cozo_db` module.\n\n```erlang\n% open a new database in memory\n{ok, Pid} = cozo_db:start([]).\n\n% run a query\n{ok,#{  > => [ >, >, >],\n        > => null,\n        > => true,\n        > => [[1,2,3]],\n        > => 0.001401927\n     }\n} = cozo_db:run(Pid, \"?[]  > => [ >, >, >],\n        > => null,\n        > => true,\n        > => [[1,2,3]],\n        > => 0.001401927\n     }\n} = cozo:run(Db, \"?[] <- [[1, 2, 3]]\").\n\n% close the database\nok = cozo:close(Db).\n```\n\nIf you want an access to a low level interface, you can also use\n`cozo_nif` module.","ref":"readme.html#usage"},{"type":"extras","title":"Examples - cozo","doc":"Some examples are present in `examples` directory like a cozo over\ntcp, you can use with telnet or netcat.\n\n```erlang\nc(\"examples/cozo_tcp.erl\").\n{ok, Pid} = cozo_tcp:start().\n```\n\n```shell\nnc localhost 6543\n# ?[] <- [[1,2,3]]\n```","ref":"readme.html#examples"},{"type":"extras","title":"References - cozo","doc":"- [Official CozoDB Website](https://www.cozodb.org/)\n - [Official CozoDB Documentation](https://docs.cozodb.org/en/latest/)\n - [Official CozoDB Repository](https://github.com/cozodb/cozo)\n - [Erlang NIF](https://www.erlang.org/doc/tutorial/nif.html)","ref":"readme.html#references"},{"type":"extras","title":"Cozo Cheatsheet","doc":"# Cozo Cheatsheet","ref":"cheatsheet.html"},{"type":"extras","title":"Environment Variables - Cozo Cheatsheet","doc":"All engines except `mem` one will create a stored database on\nfilesystem. In case of `sqlite` a single file will be created, and a\ndirectory will be generated with `rocksdb`.\n\nThe default path to store the db can be set modified by configuring\n`db_path` environment variable. **The directory used must exist**,\ncozo will not create it by default.\n\n```erlang\napplication:set_env(cozo, db_path, \"/var/tmp\").\n{ok\n, {_\n  , #cozo{\n\tdb_path = \"/var/tmp/cozodb_JGsr7QVAREITm25Xq5dAw1lOQovHjvL9\"\n\t}\n  }\n} = cozo:open().\n```\n\nStored databases are prefixed with `cozodb_` by default, but this\nvalue can be modified by modifying `db_filename_prefix` environment\nvariable.\n\n```erlang\napplication:set_env(cozo, db_filename_prefix, \"cozodb_custom_prefix_\").\n{ok\n, {_\n  , #cozo{\n\tdb_path = \"/tmp/cozodb_custom_prefixf5anxr5GZ9CJRhVPR2lLMfSviW4CGUip\"\n\t}\n  }\n} = cozo:open().\n```\n\n`mem` is the default engine used, this value can be changed by\nmodifying `engine` environment variable.\n\n```erlang\napplication:set_env(cozo, engine, sqlite).\n```\n\n`thoas` is the default JSON parser used to encode and decode JSON\nobjects. This value can be changed by modiying `json_parser`\nenvironment variable.\n\n```erlang\napplication:set_env(cozo, json_parser, thoas).\nthoas = cozo:json_encoder().\nthoas = cozo:json_decoder().\n```\n\nDatabases can use custom options passed as JSON (or `map()` in this\ninterface). By default, no options (`#{}`) are passed. This can be\nmodified by changing `sqlite_options` and `rocksdb_options`\nenvironment variables.\n\n```erlang\napplication:set_env(cozo, sqlite_options, #{ custom_option =>  > }).\napplication:set_env(cozo, rocksdb_options, #{ custom_option =>  > }).\n```\n\nThe default path to load `cozo_nif.so` file is set to the `priv`\ndirectory linked from this project. This value can be changed by\nmodifying `lib_path` environment variable.\n\n```erlang\napplication:set_env(cozo, lib_path, \"/usr/lib\").\n```","ref":"cheatsheet.html#environment-variables"},{"type":"extras","title":"Maintenance Commands - Cozo Cheatsheet","doc":"A list of functions have been created to help developers to deal with\nmaintenance commands:\n\n  - `list_relations/1`\n  - `remove_relation/2`\n  - `remove_relations/2`\n  - `create_relation/3`\n  - `replace_relation/3`\n  - `put_row/3`\n  - `update_row/3`\n  - `remove_row/3`\n  - `ensure_row/3`\n  - `ensure_not_row/3`\n  - `list_columns/2`\n  - `list_indices/2`\n  - `explain/2`\n  - `describe/3`\n  - `get_triggers/2`\n  - `set_access_level/3`\n  - `set_access_levels/3`\n  - `get_running_queries/1`\n  - `kill/2`\n  - `compact/1`","ref":"cheatsheet.html#maintenance-commands"},{"type":"extras","title":"Examples - Cozo Cheatsheet","doc":"Test suites in `test` contain the full tutorial from cozodb official\ndocumentation.","ref":"cheatsheet.html#examples"},{"type":"extras","title":"LICENSE","doc":"Copyright 2023 Mathieu Kerjouan\n\nRedistribution and use in source and binary forms, with or without\nmodification, are permitted provided that the following conditions are\nmet:\n\n1. Redistributions of source code must retain the above copyright\n   notice, this list of conditions and the following disclaimer.\n\n2. Redistributions in binary form must reproduce the above copyright\n   notice, this list of conditions and the following disclaimer in the\n   documentation and/or other materials provided with the\n   distribution.\n\nTHIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS\n“AS IS” AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT\nLIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR\nA PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT\nHOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,\nSPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT\nLIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,\nDATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY\nTHEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT\n(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE\nOF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.","ref":"license.html"}],"content_type":"text/plain"}